package com.loit.shardingsphere.seata.nacos.feign.controller;


import com.loit.shardingsphere.seata.nacos.feign.modules.entity.OrderEntity;
import com.loit.shardingsphere.seata.nacos.feign.modules.service.IBusinessService;
import com.loit.shardingsphere.seata.nacos.feign.modules.service.IOrderService;
import lombok.extern.slf4j.Slf4j;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.annotation.Resource;
import java.util.List;

/**
 * 前端控制器
 */
@RestController
@RequestMapping("/demo")
@Slf4j
public class DemoController {

    @Resource(name = "businessService")
    IBusinessService businessService;

    @Resource(name = "orderService")
    IOrderService orderService;

    @GetMapping("purchase")
    public void purchase() {
        for (long i = 1; i < 20; i++) {
            try {
                businessService.purchase(i);
            } catch (Exception e) {
                log.info(e.getMessage(), e);
            }
        }
        log.info("success");
    }

    @GetMapping("findPage")
    public void findPage() {
        List<OrderEntity> pageList = orderService.findPage(0l, 5l);
        log.info(pageList.toString());
    }


}

