package com.loit.shardingsphere.seata.nacos.feign.modules.service.impl;

import com.loit.shardingsphere.seata.nacos.feign.modules.entity.OrderEntity;
import com.loit.shardingsphere.seata.nacos.feign.modules.service.IBusinessService;
import com.loit.shardingsphere.seata.nacos.feign.modules.service.IOrderService;
import org.apache.shardingsphere.transaction.annotation.ShardingTransactionType;
import org.apache.shardingsphere.transaction.core.TransactionType;
import org.apache.shardingsphere.transaction.core.TransactionTypeHolder;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

@Service("businessService")
public class BusinessServiceImpl implements IBusinessService {

    @Autowired
    IOrderService orderService;

    /**
     * 分库分表 使用全局事务
     *
     * @param userId
     */
    @Override
    @ShardingTransactionType(TransactionType.LOCAL)
    //@GlobalTransactional
    @Transactional
    public void purchase(Long userId) {
        if (userId == null) {
            return;
        }
        TransactionTypeHolder.set(TransactionType.LOCAL);
        OrderEntity orderEntity = new OrderEntity();
        orderEntity.setOrderId(userId);
        orderEntity.setStatus("seata");
        orderEntity.setUserId(userId.intValue());
        orderService.insertOrder(orderEntity);
        //throw new RuntimeException("回滚测试");
    }


    /**
     * 分表 使用本地事务
     * @param userId
     */
//    @Override
//    @ShardingTransactionType(TransactionType.LOCAL)
//    @Transactional
//    public void purchase(Long userId) {
//        if (userId == null) {
//            return;
//        }
//        TransactionTypeHolder.set(TransactionType.LOCAL);
//        OrderEntity orderEntity = new OrderEntity();
//        orderEntity.setOrderId(userId);
//        orderEntity.setStatus("seata");
//        orderEntity.setUserId(userId.intValue());
//        orderService.insertOrder(orderEntity);
//        throw new RuntimeException("回滚测试");
//    }
}
