package com.loit.shardingsphere.seata.nacos.feign.modules.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;

import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.loit.shardingsphere.seata.nacos.feign.modules.entity.OrderEntity;
import com.loit.shardingsphere.seata.nacos.feign.modules.mapper.OrderMapper;
import com.loit.shardingsphere.seata.nacos.feign.modules.service.IOrderService;
import org.springframework.stereotype.Service;

import java.util.List;

@Service("orderService")
public class OrderServiceImpl extends ServiceImpl<OrderMapper, OrderEntity> implements IOrderService {

    @Override
    public void insertOrder(OrderEntity orderEntity) {
        baseMapper.insert(orderEntity);
    }

    @Override
    public List<OrderEntity> findPage(Long pageNum, Long pageSize) {
        QueryWrapper<OrderEntity> queryWrapper = new QueryWrapper<>();
        queryWrapper.orderByAsc("id");
        Page<OrderEntity> page = new Page<>(pageNum, pageSize);
        //分页数据
        IPage<OrderEntity> pageInfo = this.page(page, queryWrapper);
        return pageInfo.getRecords();
    }


}
